diff --git a/yum/sqlitesack.py b/yum/sqlitesack.py
index 8a6f6f3..4d91774 100644
--- a/yum/sqlitesack.py
+++ b/yum/sqlitesack.py
@@ -52,6 +52,8 @@ def catchSqliteException(func):
                     raise Errors.RepoError, str(e.message)
                 else:
                     raise Errors.RepoError, str(e)
+            #  Note that we can't easily get "repo" here, AFAIK. So we can't
+            # tell what failed.
             raise Errors.RepoError, str(e)
 
     newFunc.__name__ = func.__name__
@@ -69,7 +71,7 @@ def _parse_pkg_n(match, regexp_match, n):
     if not regexp_match:
         return False
 
-    if (match and n and match[0] not in ('?', '*') and match[0] != n[0]):
+    if (match and n and match[0] not in ('?', '*', '[') and match[0] != n[0]):
         return False
     if regexp_match(n):
         return True
@@ -82,7 +84,7 @@ def _parse_pkg(match, regexp_match, data, e,v,r,a):
     # Worthless speed hacks?
     if match == n:
         return True
-    if (match and n and match[0] not in ('?', '*') and
+    if (match and n and match[0] not in ('?', '*', '[') and
         match[0] != n[0] and match[0] != e[0]):
         return False
 
@@ -179,7 +181,11 @@ class YumAvailablePackageSqlite(YumAvailablePackage, PackageObject, RpmBase):
         self.prco = { 'obsoletes': (),
                       'conflicts': (),
                       'requires': (),
-                      'provides': () }
+                      'provides': (),
+                      'suggests': (),
+                      'enhances': (),
+                      'recommends': (),
+                      'supplements': () }
         self.sack = repo.sack
         self.repoid = repo.id
         self.repo = repo
@@ -298,13 +304,14 @@ class YumAvailablePackageSqlite(YumAvailablePackage, PackageObject, RpmBase):
                            "WHERE  packages.pkgId = ?", (self.pkgId,))
         for ob in cur:
             dirname = ob['dirname']
+            if dirname == '.':
+                dirname = ''
+            elif dirname and dirname[-1] != '/':
+                dirname += '/'
             filetypes = decodefiletypelist(ob['filetypes'])
             filenames = decodefilenamelist(ob['filenames'])
             while(filetypes):
-                if dirname:
-                    filename = dirname+'/'+filenames.pop()
-                else:
-                    filename = filenames.pop()
+                filename = dirname + filenames.pop()
                 filetype = _share_data(filetypes.pop())
                 result.setdefault(filetype,[]).append(filename)
         self._loadedfiles = True
@@ -382,7 +389,21 @@ class YumAvailablePackageSqlite(YumAvailablePackage, PackageObject, RpmBase):
 
     def returnPrco(self, prcotype, printable=False):
         prcotype = _share_data(prcotype)
-        if isinstance(self.prco[prcotype], tuple):
+        if prcotype == 'strong_requires':
+            # pkg not installed so we don't know require flags yet
+            # returning all requires should work in most cases
+            prcotype = 'requires'
+
+        # Check for the new weak deps. tables...
+        sql_table_exists = True
+        if prcotype in ('suggests', 'enhances', 'recommends', 'supplements'):
+            cur = self._sql_MD('primary', "PRAGMA table_info(%s)" % prcotype)
+            for ob in cur:
+                break
+            else:
+                sql_table_exists = False
+
+        if sql_table_exists and isinstance(self.prco[prcotype], tuple):
             sql = "SELECT name, version, release, epoch, flags " \
                   "FROM %s WHERE pkgKey = ?" % prcotype
             cur = self._sql_MD('primary', sql, (self.pkgKey,))
@@ -406,7 +427,7 @@ class YumAvailablePackageSqlite(YumAvailablePackage, PackageObject, RpmBase):
         requires = []
         for ob in cur:
             pre = "0"
-            if ob['pre'].lower() in ['TRUE', 1]:
+            if ob['pre'].lower() in ['true', 1]:
                 pre = "1"
             prco_set = (_share_data(ob['name']), _share_data(ob['flags']),
                         (_share_data(ob['epoch']),
@@ -729,7 +750,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
             data = self._sql_MD('primary', repo, sql, (pkgKey,)).fetchone()
             if data is None:
                 msg = "pkgKey %s doesn't exist in repo %s" % (pkgKey, repo)
-                raise Errors.RepoError, msg
+                raise Errors.RepoError(msg, repo=repo)
             if exclude and self._pkgExcludedRKD(repo, pkgKey, data):
                 return None
             po = self.pc(repo, data)
@@ -798,7 +819,8 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
             self.excludes[repo] = {}
 
         if dataobj is None:
-            raise Errors.RepoError, "Tried to add None %s to %s" % (datatype, repo)
+            raise Errors.RepoError("Tried to add None %s to %s" % (datatype, repo),
+                                   repo=repo)
 
         if datatype == 'metadata':
             self.primarydb[repo] = dataobj
@@ -808,7 +830,8 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
             self.otherdb[repo] = dataobj
         else:
             # We can not handle this yet...
-            raise Errors.RepoError, "Sorry sqlite does not support %s in %s" % (datatype, repo)
+            raise Errors.RepoError("Sorry sqlite does not support %s in %s" % (datatype, repo),
+                                   repo=repo)
     
         self.added[repo].append(datatype)
 
@@ -917,8 +940,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
 
         # ultra simple optimization 
         if misc.re_primary_filename(name):
-            if not misc.re_glob(dirname): # is the dirname a glob?
-                return self._search_primary_files(name)
+            return self._search_primary_files(name)
         
         if len(self.filelistsdb) == 0:
             # grab repo object from primarydb and force filelists population in this sack using repo
@@ -938,7 +960,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
             pri_pkgs = self._sql_MD_pkg_num('primary',   repo)
             fil_pkgs = self._sql_MD_pkg_num('filelists', repo)
             if pri_pkgs != fil_pkgs:
-                raise Errors.RepoError
+                raise Errors.RepoError('Check of Primary and Filelists sync. failed.', repo=repo)
             repo._checked_filelists_pkgs = True
 
         sql_params = []
@@ -1560,7 +1582,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
             patterns = tmp
         return (need_full, patterns, fields, False)
 
-    @catchSqliteException
+    # @catchSqliteException has no effect on generators
     def _yieldSQLDataList(self, repoid, patterns, fields, ignore_case):
         """Yields all the package data for the given params. Excludes are done
            at this stage. """
@@ -1593,6 +1615,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
                 for x in cur:
                     yield (repo, x)
 
+    @catchSqliteException
     def _buildPkgObjList(self, repoid=None, patterns=None, ignore_case=False):
         """Builds a list of packages, only containing nevra information.
            Excludes are done at this stage. """
@@ -1666,6 +1689,7 @@ class YumSqlitePackageSack(yumRepo.YumPackageSack):
 
         return returnList
 
+    @catchSqliteException
     def simplePkgList(self, patterns=None, ignore_case=False):
         """Returns a list of pkg tuples (n, a, e, v, r), optionally from a
            single repoid. Note that the packages are always filtered to those
diff --git a/yum/sqlutils.py b/yum/sqlutils.py
index 4d7e36e..826ad62 100644
--- a/yum/sqlutils.py
+++ b/yum/sqlutils.py
@@ -50,7 +50,7 @@ def Tokenize(str, whitespace=" \t\r\n", quotes="\"", escapes="\\"):
 
     @param        str: string to tokenize
     @type         str: string
-    @param whitespace: whitespace characters seperating tokens
+    @param whitespace: whitespace characters separating tokens
     @type  whitespace: string
     @param     quotes: legal quoting characters
     @type      quotes: string
diff --git a/yum/transactioninfo.py b/yum/transactioninfo.py
index 4d89d83..9ce5025 100644
--- a/yum/transactioninfo.py
+++ b/yum/transactioninfo.py
@@ -34,6 +34,8 @@ import Errors
 import warnings
 import misc
 
+import time
+
 class GetProvReqOnlyPackageSack(PackageSack):
     def __init__(self, need_files=False):
         PackageSack.__init__(self)
@@ -84,10 +86,13 @@ class TransactionData:
         self.changed = False
         self.installonlypkgs = []
         self.state_counter = 0
+        self.tm_created = time.time()
+        self.tm_changed = time.time()
         self.conditionals = {} # key = pkgname, val = list of pos to add
 
         self.rpmdb = None
-        self.pkgSack = None
+        self._pkgSack = None
+        self._pkgSackCtor = None
         self.pkgSackPackages = 0
         self.localSack = PackageSack()
         self._inSack = GetProvReqOnlyPackageSack()
@@ -95,6 +100,8 @@ class TransactionData:
         # lists of txmbrs in their states - just placeholders
         self.instgroups = []
         self.removedgroups = []
+        self.instenvironments = []
+        self.removedenvironments = []
         self.removed = []
         self.installed = []
         self.updated = []
@@ -105,6 +112,14 @@ class TransactionData:
         self.reinstalled = []
         self.downgraded = []
         self.failed = []
+
+        self._future_rpmdbv = None
+        self._check_future_rpmdbv = None
+
+    def _changed(self):
+        self.changed = True
+        self.state_counter += 1
+        self.tm_changed = time.time()
         
     def __len__(self):
         return len(self.pkgdict)
@@ -115,6 +130,18 @@ class TransactionData:
         else:
             return iter(self.getMembers())
 
+    def _getPkgSack(self):
+        if self._pkgSack is not None:
+            return self._pkgSack
+        if self._pkgSackCtor is not None:
+            self._pkgSack = self._pkgSackCtor()
+        return self._pkgSack
+
+    pkgSack = property(fget=lambda self: self._getPkgSack(),
+                       fset=lambda self, value: setattr(self, "_pkgSack",value),
+                       fdel=lambda self: setattr(self, "_pkgSack", None),
+                       doc="Package sack object")
+
     def debugprint(self, msg):
         if self.debug:
             print msg
@@ -208,7 +235,9 @@ class TransactionData:
                 txmbrs = self.matchNaevr(na[0], na[1])
 
         if not txmbrs:
-            if self.pkgSack is None:
+            if self._inSack is not None:
+                pkgs = self._inSack.returnPackages(patterns=[pattern])
+            elif self.pkgSack is None:
                 pkgs = []
             else:
                 pkgs = self.pkgSack.returnPackages(patterns=[pattern])
@@ -236,6 +265,8 @@ class TransactionData:
         # happens IRL.
         return txmember.ts_state in ('u', 'i') and not isinstance(txmember.po, (YumInstalledPackage, YumAvailablePackageSqlite))
 
+    # NOTE: This is a copy of Depsolve.allowedMultipleInstalls() because
+    #       we can't get to YumBase from here. Use that as the main/public API.
     def _allowedMultipleInstalls(self, po):
         """takes a packageObject, returns 1 or 0 depending on if the package 
            should/can be installed multiple times with different vers
@@ -266,8 +297,8 @@ class TransactionData:
                     return
         self.pkgdict[txmember.pkgtup].append(txmember)
         self._namedict.setdefault(txmember.name, []).append(txmember)
-        self.changed = True
-        self.state_counter += 1
+        self._changed()
+
         if self._isLocalPackage(txmember):
             self.localSack.addPackage(txmember.po)
         elif isinstance(txmember.po, YumAvailablePackageSqlite):
@@ -307,8 +338,7 @@ class TransactionData:
         del self.pkgdict[pkgtup]
         if not self._namedict[pkgtup[0]]:
             del self._namedict[pkgtup[0]]
-        self.changed = True        
-        self.state_counter += 1
+        self._changed()
     
     def exists(self, pkgtup):
         """tells if the pkg is in the class"""
@@ -334,6 +364,8 @@ class TransactionData:
            
         self.instgroups = []
         self.removedgroups = []
+        self.instenvironments = []
+        self.removedenvironments = []
         self.removed = []
         self.installed = []
         self.updated = []
@@ -365,7 +397,13 @@ class TransactionData:
                     for g in txmbr.groups:
                         if g not in self.instgroups:
                             self.instgroups.append(g)
-                if txmbr.isDep:
+                if txmbr.environments:
+                    for evg in txmbr.environments:
+                        if evg not in self.instenvironments:
+                            self.instenvironments.append(evg)
+                #  "user" here is kind of a hack ... we really shouldn't have
+                # .isDep == True, but this probably doesn't hurt.
+                if txmbr.isDep and txmbr.reason != 'user':
                     self.depinstalled.append(txmbr)
                 else:
                     self.installed.append(txmbr)
@@ -377,6 +415,9 @@ class TransactionData:
                 for g in txmbr.groups:
                     if g not in self.instgroups:
                         self.removedgroups.append(g)
+                for evg in txmbr.environments:
+                    if evg not in self.instenvironments:
+                        self.removedenvironments.append(evg)
                 if txmbr.isDep:
                     self.depremoved.append(txmbr)
                 else:
@@ -402,6 +443,8 @@ class TransactionData:
         self.depremoved.sort()
         self.instgroups.sort()
         self.removedgroups.sort()
+        self.instenvironments.sort()
+        self.removedenvironments.sort()
         self.reinstalled.sort()
         self.downgraded.sort()
         self.failed.sort()
@@ -418,7 +461,6 @@ class TransactionData:
         txmbr.output_state = TS_INSTALL
         txmbr.po.state = TS_INSTALL        
         txmbr.ts_state = 'u'
-        txmbr.reason = 'user'
 
         if self.rpmdb.contains(po=txmbr.po):
             txmbr.reinstall = True
@@ -436,7 +478,6 @@ class TransactionData:
         txmbr.output_state = TS_TRUEINSTALL
         txmbr.po.state = TS_INSTALL        
         txmbr.ts_state = 'i'
-        txmbr.reason = 'user'
 
         if self.rpmdb.contains(po=txmbr.po):
             txmbr.reinstall = True
@@ -478,7 +519,7 @@ class TransactionData:
         return txmbr
 
     def addDowngrade(self, po, oldpo):
-        """adds a package as an downgrade takes a packages object and returns
+        """adds a package as a downgrade takes a packages object and returns
            a pair of TransactionMember Objects"""
 
         itxmbr = self.addErase(oldpo)
@@ -489,6 +530,10 @@ class TransactionData:
         if not atxmbr: # Fail?
             self.remove(itxmbr.pkgtup)
             return None
+
+        if 'reason' in oldpo.yumdb_info:
+            atxmbr.reason = oldpo.yumdb_info.reason
+
         atxmbr.relatedto.append((oldpo, 'downgrades'))
         atxmbr.downgrades.append(oldpo)
 
@@ -505,6 +550,10 @@ class TransactionData:
         txmbr.ts_state = 'ud'
         txmbr.relatedto.append((updating_po, 'updatedby'))
         txmbr.updated_by.append(updating_po)
+
+        if 'reason' in po.yumdb_info: # Propbably worthless, but...
+            txmbr.reason = po.yumdb_info.reason
+
         self.add(txmbr)
         return txmbr
 
@@ -537,6 +586,10 @@ class TransactionData:
         txmbr.ts_state = 'od'
         txmbr.relatedto.append((obsoleting_po, 'obsoletedby'))
         txmbr.obsoleted_by.append(obsoleting_po)
+
+        if 'reason' in po.yumdb_info: # Propbably worthless, but...
+            txmbr.reason = po.yumdb_info.reason
+
         self.add(txmbr)
         for otxmbr in self.getMembersWithState(obsoleting_po.pkgtup,
                                                [TS_OBSOLETING]):
@@ -547,9 +600,10 @@ class TransactionData:
         return txmbr
 
 
-    def setDatabases(self, rpmdb, pkgSack):
+    def setDatabases(self, rpmdb, pkgSack, pkgSackCtor=None):
         self.rpmdb = rpmdb
-        self.pkgSack = pkgSack
+        self._pkgSack     = pkgSack
+        self._pkgSackCtor = pkgSackCtor
 
     def getNewProvides(self, name, flag=None, version=(None, None, None)):
         """return dict { packages -> list of matching provides }
@@ -619,6 +673,12 @@ class TransactionData:
         """ Return a simple version for the future rpmdb. Works like
             rpmdb.simpleVersion(main_only=True)[0], but for the state the rpmdb
             will be in after the transaction. """
+
+        if self._future_rpmdbv is not None:
+            sc, ret = self._future_rpmdbv
+            if sc == self.state_counter:
+                return ret
+
         pkgs = self.rpmdb.returnPackages()
         _reinstalled_pkgtups = {}
         for txmbr in self.getMembersWithState(None, TS_INSTALL_STATES):
@@ -658,6 +718,7 @@ class TransactionData:
 
         self.rpmdb.transactionCachePackageChecksums(pkg_checksum_tups)
 
+        self._future_rpmdbv = (self.state_counter, main)
         return main
     
     def findObsoletedByThisMember(self, txmbr):
@@ -752,6 +813,8 @@ class TransactionMember:
         self.downgraded_by = []
         self.reinstall = False
         self.groups = [] # groups it's in
+        self.environments = [] # Env. groups it's in
+        self.repopkg = None # repo pkg "group" it was removed/installed by
         self._poattr = ['pkgtup', 'repoid', 'name', 'arch', 'epoch', 'version',
                         'release']
 
@@ -767,15 +830,34 @@ class TransactionMember:
             po.yumdb_info.get('releasever')
             po.yumdb_info.get('changed_by')
 
-    def setAsDep(self, po=None):
+    def setAsDep(self, po=None, relonly=False):
         """sets the transaction member as a dependency and maps the dep into the
            relationship list attribute"""
-        
-        self.isDep = 1
+
+        if not relonly:
+            self.isDep = 1
         if po:
             self.relatedto.append((po, 'dependson'))
             self.depends_on.append(po)
 
+    def removeDep(self, po):
+        """sets the transaction member as a dependency and maps the dep into the
+           relationship list attribute"""
+
+        nrelto = []
+        for data in self.relatedto:
+            if data[0] == po:
+                continue
+            nrelto.append(data)
+        self.relatedto = nrelto
+
+        ndepon = []
+        for data in self.depends_on:
+            if data == po:
+                continue
+            ndepon.append(data)
+        self.depends_on = ndepon
+
     def __cmp__(self, other):
         return cmp(self.po, other.po)
 
@@ -825,5 +907,9 @@ class TransactionMember:
                 
         if self.groups:
             msg += "  groups: %s\n" % ' '.join(self.groups)
+        if self.environments:
+            msg += "  environments: %s\n" % ' '.join(self.environments)
+        if self.repopkg:
+            msg += "  repopkg: %s\n" % self.repopkg
 
         return msg
diff --git a/yum/update_md.py b/yum/update_md.py
index 2cb1acb..a62bc00 100644
--- a/yum/update_md.py
+++ b/yum/update_md.py
@@ -23,23 +23,28 @@ Update metadata (updateinfo.xml) parsing.
 
 import sys
 
-from yum.i18n import utf8_text_wrap, to_utf8, to_unicode
+from yum.i18n import utf8_text_wrap, to_utf8, to_unicode, _
 from yum.yumRepo import YumRepository
 from yum.packages import FakeRepository
 from yum.misc import to_xml, decompress, repo_gen_decompress
 from yum.misc import cElementTree_iterparse as iterparse 
 import Errors
 
+import logginglevels
+
 import rpmUtils.miscutils
 
 
-def safe_iterparse(filename):
+def safe_iterparse(filename, logger=None):
     """ Works like iterparse, but hides XML errors (prints a warning). """
     try:
         for event, elem in iterparse(filename):
             yield event, elem
     except SyntaxError: # Bad XML
-        print >> sys.stderr, "File is not valid XML:", filename
+        if logger:
+            logger.critical(_("Updateinfo file is not valid XML: %s"), filename)
+        else:
+            print >> sys.stderr, "Updateinfo file is not valid XML:", filename
 
 class UpdateNoticeException(Exception):
     """ An exception thrown for bad UpdateNotice data. """
@@ -79,11 +84,53 @@ class UpdateNotice(object):
 
     def __getitem__(self, item):
         """ Allows scriptable metadata access (ie: un['update_id']). """
-        return self._md.get(item) or None
+        if type(item) is int:
+            return sorted(self._md)[item]
+        ret = self._md.get(item)
+        if ret == '':
+            ret = None
+        return ret
+
+    def __contains__(self, item):
+        """ Allows quick tests for foo in blah. """
+        return item in self._md
 
     def __setitem__(self, item, val):
         self._md[item] = val
 
+    def __eq__(self, other):
+        #  Tests to see if it's "the same data", which means that the
+        # packages can be different (see add_notice).
+
+        if not other or not hasattr(other, '_md'):
+            return False
+
+        for data in ('type', 'update_id', 'status', 'rights',
+                     'severity', 'release',
+                     'issued', 'updated', 'version', 'pushcount',
+                     'from', 'title', 'summary', 'description', 'solution'):
+            if data == 'status': # FIXME: See below...
+                continue
+            if self._md[data] != other._md[data]:
+                return False
+        # FIXME: Massive hack, Fedora is really broken and gives status=stable
+        # and status=testing for updateinfo notices, just depending on which
+        # repo. they come from.
+        data = 'status'
+        if self._md[data] != other._md[data]:
+            if self._md[data]  not in ('stable', 'testing'):
+                return False
+            if other._md[data] not in ('stable', 'testing'):
+                return False
+            # They are both really "stable" ...
+            self._md[data]  = 'stable'
+            other._md[data] = 'stable'
+
+        return True
+
+    def __ne__(self, other):
+        return not (self == other)
+
     def text(self, skip_data=('files', 'summary', 'rights', 'solution')):
         head = """
 ===============================================================================
@@ -304,7 +351,9 @@ class UpdateNotice(object):
                 to_xml(self._md['title']), to_xml(self._md['release']),
                 to_xml(self._md['issued'], attrib=True),
                 to_xml(self._md['description']))
-
+        if self._md['updated']:
+            # include the updated date in the generated xml
+            msg += """ <updated date="%s"/>\n""" % (to_xml(self._md['updated'], attrib=True))
         if self._md['summary']:
             msg += """  <summary>%s</summary>\n""" % (to_xml(self._md['summary']))
         if self._md['solution']:
@@ -336,16 +385,17 @@ class UpdateNotice(object):
                       to_xml(coll['name']))
   
                 for pkg in coll['packages']:
-                    msg += """      <package arch="%s" name="%s" release="%s" src="%s" version="%s">
+                    msg += """      <package arch="%s" name="%s" release="%s" src="%s" version="%s" epoch="%s">
         <filename>%s</filename>
       </package>\n""" % (to_xml(pkg['arch'], attrib=True),
                                 to_xml(pkg['name'], attrib=True),
                                 to_xml(pkg['release'], attrib=True),
                                 to_xml(pkg['src'], attrib=True),
                                 to_xml(pkg['version'], attrib=True),
+                                to_xml(pkg['epoch'] or '0', attrib=True),
                                 to_xml(pkg['filename']))
                 msg += """    </collection>\n"""
-                msg += """  </pkglist>\n"""
+            msg += """  </pkglist>\n"""
         msg += """</update>\n"""
         return msg
 
@@ -360,11 +410,15 @@ class UpdateMetadata(object):
     The root update metadata object.
     """
 
-    def __init__(self, repos=[]):
+    def __init__(self, repos=[], logger=None, vlogger=None):
         self._notices = {}
         self._cache = {}    # a pkg nvr => notice cache for quick lookups
         self._no_cache = {}    # a pkg name only => notice list
         self._repos = []    # list of repo ids that we've parsed
+
+        self._logger  = logger
+        self._vlogger = vlogger
+
         for repo in repos:
             try: # attempt to grab the updateinfo.xml.gz from the repodata
                 self.add(repo)
@@ -423,8 +477,41 @@ class UpdateMetadata(object):
     def add_notice(self, un):
         """ Add an UpdateNotice object. This should be fully populated with
             data, esp. update_id and pkglist/packages. """
-        if not un or not un["update_id"] or un['update_id'] in self._notices:
-            return
+        if not un or not un["update_id"]:
+            return False
+
+        #  This is "special", the main thing we want to deal with here is
+        # having one errata that has multiple packages in it rpmA and rpmB, but
+        # the packages are in repos. repoA and repoB. So instead of doing a
+        # single errata pointing to both rpmA and rpmB and put the same thing
+        # in both repodata (which is legal, and works fine) people want to have
+        # just the packages from repoA in the repodata for repoA and vice versa.
+        if un['update_id'] in self._notices:
+            oun = self._notices[un['update_id']]
+            if oun != un:
+                return False
+
+            # Ok, main parts of errata are the same, so now merge references:
+            seen = set()
+            for ref in oun['references']:
+                seen.add(ref['id'])
+            for ref in un['references']:
+                if ref['id'] in seen:
+                    continue
+                seen.add(ref['id'])
+                oun['references'].append(ref)
+
+            # ...and pkglist (this assumes that a pkglist name XYZ is the same):
+            seen = set()
+            for pkg in oun['pkglist']:
+                seen.add(pkg['name'])
+            for pkg in un['pkglist']:
+                if pkg['name'] in seen:
+                    continue
+                seen.add(pkg['name'])
+                oun['pkglist'].append(pkg)
+
+            un = oun
 
         self._notices[un['update_id']] = un
         for pkg in un['pkglist']:
@@ -435,16 +522,26 @@ class UpdateMetadata(object):
                 no = self._no_cache.setdefault(filedata['name'], set())
                 no.add(un)
 
+        return True
+
     def add(self, obj, mdtype='updateinfo'):
         """ Parse a metadata from a given YumRepository, file, or filename. """
+
+        def _rid(repoid, fmt=_(' (from %s)')):
+            if not repoid:
+                return ''
+            return fmt % repoid
+
         if not obj:
             raise UpdateNoticeException
+        repoid = None
         if type(obj) in (type(''), type(u'')):
             unfile = decompress(obj)
             infile = open(unfile, 'rt')
 
         elif isinstance(obj, YumRepository):
             if obj.id not in self._repos:
+                repoid = obj.id
                 self._repos.append(obj.id)
                 md = obj.retrieveMD(mdtype)
                 if not md:
@@ -456,15 +553,28 @@ class UpdateMetadata(object):
         else:   # obj is a file object
             infile = obj
 
-        for event, elem in safe_iterparse(infile):
+        have_dup = False
+        for event, elem in safe_iterparse(infile, logger=self._logger):
             if elem.tag == 'update':
                 try:
                     un = UpdateNotice(elem)
                 except UpdateNoticeException, e:
-                    print >> sys.stderr, "An update notice is broken, skipping."
-                    # what else should we do?
+                    msg = _("An update notice%s is broken, skipping.") % _rid(repoid)
+                    if self._vlogger:
+                        self._vlogger.log(logginglevels.DEBUG_1, "%s", msg)
+                    else:
+                        print >> sys.stderr, msg
                     continue
-                self.add_notice(un)
+
+                if not self.add_notice(un):
+                    msg = _("Update notice %s%s is broken, or a bad duplicate, skipping.") % (un['update_id'], _rid(repoid))
+                    if not have_dup:
+                        msg += _('\nYou should report this problem to the owner of the %srepository.') % _rid(repoid, "%s ")
+                    have_dup = True
+                    if self._vlogger:
+                        self._vlogger.warn("%s", msg)
+                    else:
+                        print >> sys.stderr, msg
 
     def __unicode__(self):
         ret = u''
